## qtbase-opensource-src 5.3.2+dfsg

=== tests/auto/cmake/test_dbus_module/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_dbus_module)

find_package(Qt5DBus 5.0.0 REQUIRED)

include_directories(
    ${Qt5DBus_INCLUDE_DIRS}
)

add_definitions(${Qt5DBus_DEFINITIONS})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5DBus_EXECUTABLE_COMPILE_FLAGS}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(my_srcs mydbusobject.cpp)

qt5_wrap_cpp(moc_files mydbusobject.h)

qt5_generate_dbus_interface(
    mydbusobject.h
    ${CMAKE_BINARY_DIR}/org.qtProject.Tests.MyDBusObject.xml
)

qt5_add_dbus_adaptor(my_srcs
    ${CMAKE_BINARY_DIR}/org.qtProject.Tests.MyDBusObject.xml
    mydbusobject.h
    MyDBusObject
)

add_executable(myobject ${my_srcs} ${moc_files})
target_link_libraries(myobject ${Qt5DBus_LIBRARIES})

=== tests/auto/cmake/test_multiple_find_package/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_multiple_find_package)

find_package(Qt5Core REQUIRED)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

add_subdirectory(subdir1)

add_executable(exe1 "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")
include_directories(${Qt5Core_INCLUDE_DIRS})

=== debian/changelog ===
qtbase-opensource-src (5.3.2+dfsg-4+deb8u1~bpo70+1) wheezy-backports; urgency=medium

  * Backport latest upload to Jessie which fixes several CVEs.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 19 May 2015 15:25:19 -0300

qtbase-opensource-src (5.3.2+dfsg-4+deb8u1) stable-proposed-updates; urgency=medium

  [ Dmitry Shachnev ]
  * Fix several DoS vulnerabilities in the image handlers.
    - CVE-2015-0295, CVE-2015-1858, CVE-2015-1859, CVE-2015-1860.
    - Closes: #779580.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 19 May 2015 13:56:37 -0300

qtbase-opensource-src (5.3.2+dfsg-4~bpo70+1) wheezy-backports; urgency=medium

  * Set xkb-config-root as we are currently not using libxkbcommon because it
    has not been backported (Closes: #766239).

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 20 Nov 2014 23:48:01 -0300

qtbase-opensource-src (5.3.2+dfsg-4) unstable; urgency=medium

  * Move QPlatformSupport stuff from qtbase5-dev to qtbase5-private-dev, as it
    belongs there. Update Breaks+Replaces.
  * Backport fix_bug_in_internal_comparison_operator.patch to fix a UTF-8
    problem on QJson (Closes: #764452).

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Wed, 08 Oct 2014 18:28:23 -0300

qtbase-opensource-src (5.3.2+dfsg-3~bpo70+1) wheezy-backports; urgency=medium

  * Upload to wheezy-backports.
  * Use embedded harfbuzz lib. Backport requested in #750427.
  * Use embedded libxkbcommon-x11. Backport requested in #757174.
  * The KMS plugin is not built in Wheezy, remove it from the install file.
  * Update symbols files with current build log.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 02 Oct 2014 20:55:43 -0300

qtbase-opensource-src (5.3.2+dfsg-3) unstable; urgency=medium

  * Do not use precompiled headers on arm64 (Closes: #762702).
  * Update symbols files with buildds' logs.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 30 Sep 2014 00:38:45 -0300

qtbase-opensource-src (5.3.2+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * Add Adam Majer's fix_sparc_atomics.patch to let Sparc use C++11's atomics.
  * Add libxext-dev as build dependency: it's currently being pulled by
    something else, but adding it here will make things more robust.
  * Make qtbase5-dev depend on libxext-dev. Some mkspecs require it and it
    seems it's not a false positive.
  * Update symbols files with buildds' logs.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sun, 21 Sep 2014 22:40:08 -0300

qtbase-opensource-src (5.3.2+dfsg-1) experimental; urgency=medium

  [ Dmitry Shachnev ]
  * Update my e-mail address.
  * Update Vcs-Browser field to point to cgit interface.
  * Use correct exception syntax in debian/copyright.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * New upstream release.
  * Remove patches applied upstream:
    - support_mips_atomic_on_pre-mips32_archs.patch, applied upstream with a
      fix.
    - Remove-Wcast-align-from-QMAKE_CXXFLAGS.patch.
    - cmake_dont_check_existence_of_gl_filesin_qt5gui.patch.
  * Refresh patches.
  * Bump qtbase-abi to 5-3-2.
  * Remove libgstreamer* build dependencies, they are not really needed as
    there is no usage of them by grepping the code.
  * Update install files.
  * Update symbols files with buildds' and current logs.
  * Build conflict against libmariadbclient-dev until the fix for #759309
    enters unstable.
  * Mark private symbols as such.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 16 Sep 2014 13:38:11 -0300

qtbase-opensource-src (5.3.1+dfsg-6) unstable; urgency=medium

  * Release to unstable.
  * Update symbols files with buildds' logs.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 02 Sep 2014 18:10:57 -0300

qtbase-opensource-src (5.3.1+dfsg-5) experimental; urgency=medium

  [ Julián Moreno Patiño ]
  * Add support for non-sse2 processors (Closes: #754894).

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Disable the usage of system proxies by default due to
    https://bugreports.qt-project.org/browse/QTBUG-41053
  * Make libqt5core5a recommend qttranslations5-l10n. Thanks Felix Geyer
    for the pointer.
  * Build SSE2 enabled libraries in override_dh_auto_install-arch in order to
    avoid rewriting the previously built versions before installing them.
  * Disable pre compiled headers support when building both non SEE2 and SSE2
    libraries, as it is not compatible.
  * Create new install files for archs which uses i386 processor.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Mon, 01 Sep 2014 18:53:46 -0300

=== debian/control ===
Source: qtbase-opensource-src
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>,
           Modestas Vainius <modax@debian.org>,
           Sune Vuorela <debian@pusling.com>,
           Pino Toscano <pino@debian.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Timo Jyrinki <timo@debian.org>,
           Dmitry Shachnev <mitya57@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1),
               firebird-dev [amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc s390 sh4 sparc],
               freetds-dev,
               gdb,
               libasound2-dev [linux-any],
               libatspi2.0-dev,
               libcups2-dev,
               libdbus-1-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev [linux-any],
               libgl1-mesa-dev | libgl-dev,
               libgles2-mesa-dev [linux-any] | libgles2-dev [linux-any],
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk2.0-dev,
               libicu-dev,
               libjpeg-dev,
               libmtdev-dev [linux-any],
               libmysqlclient-dev,
               libopenvg1-mesa-dev [!hurd-any],
               libpng-dev,
               libpq-dev,
               libpulse-dev,
               libsqlite3-dev,
               libssl-dev,
               libudev-dev [linux-any],
               libx11-dev,
               libx11-xcb-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-render-util0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-xfixes0-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxext-dev,
               libxi-dev,
               libxrender-dev,
               pkg-kde-tools (>= 0.14.2),
               unixodbc-dev,
               zlib1g-dev
Build-Conflicts: libmariadbclient-dev
Standards-Version: 3.9.5
Homepage: http://qt-project.org/
Vcs-Git: git://anonscm.debian.org/pkg-kde/qt/qtbase.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/qt/qtbase.git

Package: libqt5core5a
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Provides: qtbase-abi-5-3-2
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: qttranslations5-l10n
Suggests: libthai0
Breaks: libqt5core5 (<< 5.2.0+dfsg~)
Replaces: libqt5core5 (<< 5.2.0+dfsg~)
Description: Qt 5 core module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtCore module contains core non-GUI functionality.

Package: libqt5gui5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 GUI module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtGui module extends QtCore with GUI functionality.

Package: libqt5network5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 network module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtNetwork module offers classes that allow you to write TCP/IP clients and
 servers. It provides classes to make network programming easier and portable.

Package: libqt5opengl5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 OpenGL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtOpenGL module offers classes that make it easy to use OpenGL in Qt
 applications.
 .
 OpenGL is a standard API for rendering 3D graphics. OpenGL only deals with 3D
 rendering and provides little or no support for GUI programming issues.

Package: libqt5sql5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libqt5sql5-sqlite | libqt5sql5-mysql | libqt5sql5-odbc | libqt5sql5-psql | libqt5sql5-ibase [amd64 armel i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc s390 sh4 sparc]
Description: Qt 5 SQL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtSql module helps you provide seamless database integration to your Qt
 applications.

Package: libqt5sql5-mysql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 MySQL database driver
 This package contains the MySQL plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MySQL DB.

Package: libqt5sql5-odbc
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 ODBC database driver
 This package contains the ODBC plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access an
 ODBC DB.

Package: libqt5sql5-psql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 PostgreSQL database driver
 This package contains the PostgreSQL plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 PostgreSQL DB.

Package: libqt5sql5-sqlite
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 SQLite 3 database driver
 This package contains the SQLite 3 plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access an
 SQLite 3 DB.

Package: libqt5sql5-tds
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 FreeTDS database driver
 This package contains the FreeTDS plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MS SQL or Sybase SQL server.

Package: libqt5xml5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 XML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtXml module provides a stream reader and writer for XML documents,
 and C++ implementations of SAX and DOM.

Package: libqt5dbus5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 D-Bus module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtDBus module is a Unix-only library that you can use to make Inter-Process
 Communication using the D-Bus protocol.
 .
 Applications using the QtDBus module can provide services to other, remote
 applications by exporting objects, as well as use services exported by those
 applications by placing calls and accessing properties.

Package: libqt5test5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 test module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtTest module provides classes for unit testing Qt applications and
 libraries.

Package: libqt5concurrent5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 concurrent module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtConcurrent module contains functionality to support concurrent execution
 of program code.

Package: libqt5widgets5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 widgets module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtWidgets module extends QtGui with C++ widget functionality.

Package: libqt5printsupport5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libcups2
Description: Qt 5 print support module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtPrintSupport module provides classes to make printing easier and
 portable.

Package: qtbase5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgl1-mesa-dev [!armel !armhf] | libgl-dev [!armel !armhf],
         libgles2-mesa-dev [armel armhf] | libgles2-dev [armel armhf],
         libglu1-mesa-dev [!armel !armhf] | libglu-dev [!armel !armhf],
         libqt5concurrent5 (= ${binary:Version}),
         libqt5core5a (= ${binary:Version}),
         libqt5dbus5 (= ${binary:Version}),
         libqt5gui5 (= ${binary:Version}),
         libqt5network5 (= ${binary:Version}),
         libqt5printsupport5 (= ${binary:Version}),
         libqt5sql5 (= ${binary:Version}),
         libqt5test5 (= ${binary:Version}),
         libqt5widgets5 (= ${binary:Version}),
         libqt5xml5 (= ${binary:Version}),
         libxext-dev,
         qt5-qmake (= ${binary:Version}),
         qtbase5-dev-tools (= ${binary:Version}),
         qtchooser,
         ${misc:Depends}
Recommends: libqt5opengl5-dev (= ${binary:Version})
Suggests: firebird-dev,
          libegl1-mesa-dev,
          libgl1-mesa-dev,
          libmysqlclient-dev,
          libpq-dev,
          libsqlite3-dev,
          unixodbc-dev
Description: Qt 5 base development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the header development files used for building Qt 5
 applications.

Package: qtbase5-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: qtbase5-dev (= ${binary:Version}), ${misc:Depends}
Breaks: qtbase5-dev (<< 5.3.2+dfsg-4~)
Replaces: qtbase5-dev (<< 5.3.2+dfsg-4~)
Description: Qt 5 base private development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the private header development files for building some
 Qt 5 applications like Qt Creator QML Designer plugin.
 .
 Use at your own risk.

Package: libqt5opengl5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libqt5opengl5 (= ${binary:Version}),
         qtbase5-dev (= ${binary:Version}),
         ${misc:Depends}
Description: Qt 5 OpenGL library development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the development files needed to build Qt 5 applications
 using QtOpenGL library.

Package: qtbase5-dev-tools
Architecture: any
Multi-Arch: foreign
Section: devel
Depends: qtchooser, ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Description: Qt 5 base development programs
 Qt is a cross-platform C++ application framework. Qt's primary feature

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

export PATH := $(PATH):$(shell pwd)/bin
export CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# Library package list for override_dh_makeshlibs, excludes -dev -dbg
pkgs_lib := $(filter-out %-dev %-dbg,$(filter lib%,$(shell dh_listpackages)))
# Upstream changelog
upstream_changes := dist/changes-$(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-' | sed -e 's/+dfsg//')
# Current debian version (e.g.: 4:4.5.2-1)
current_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
# Specific shlibs version (e.g.: 4:4.5.2)
shlibs_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-')
# Distribution vendor
vendor := $(shell dpkg-vendor --query Vendor)

# To easier the files installation according OSes and archs, we create three
# kinds of install files: foo.install-common, foo.install-$DEB_HOST_ARCH and
# foo.install-$DEB_HOST_ARCH_OS. In this case we can fine-tune what we install.
#
# Note that if any foo.install-* file exists and foo.install exist too, the
# later will get overwritten.
#
# I've opened a bug in debhelper to allow this:
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=703201

# Retrieve packages that have a .install-common file
pkgs_with_common = $(patsubst debian/%.install-common,%,$(wildcard debian/*.install-common))
# Retrieve packages that have a .install-$DEB_HOST_ARCH file
pkgs_with_arch = $(patsubst debian/%.install-$(DEB_HOST_ARCH),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH)))
# Retrieve packages that have a .install-$DEB_HOST_ARCH_OS file
pkgs_with_os = $(patsubst debian/%.install-$(DEB_HOST_ARCH_OS),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH_OS)))


ifneq (,$(filter %-sql-ibase,$(shell dh_listpackages)))
	extra_configure_opts += -plugin-sql-ibase
else
	extra_configure_opts += -no-sql-ibase
endif

no_pch_architectures := arm64
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(no_pch_architectures)))
	extra_configure_opts += -no-pch
endif

gles2_architectures := armel armhf
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
	extra_configure_opts += -opengl es2
else
	extra_configure_opts += -opengl desktop
endif

ifneq ($(DEB_HOST_ARCH_OS),linux)
	extra_configure_opts += -no-eglfs
endif

# Compile without sse2 support on i386
# Do not use pre compiled headers in order to be able to rebuild the gui
# submodule.
ifeq ($(DEB_HOST_ARCH_CPU),i386)
	cpu_opt = -no-sse2 -no-pch
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(filter $(DEB_HOST_ARCH),alpha ia64 mips64 mips64el arm64))
	platform_arg = linux-g++
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
	platform_arg = linux-g++-64
  else
	platform_arg = linux-g++
  endif
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
	platform_arg = hurd-g++
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
	platform_arg = gnukfreebsd-g++
else
	$(error Unknown qmake mkspec for $(DEB_HOST_ARCH_OS))
endif

%:
	dh $@ --parallel --with pkgkde_symbolshelper

override_dh_auto_configure:
	./configure -confirm-license \
	            -prefix "/usr" \
	            -bindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/bin" \
	            -libdir "/usr/lib/$(DEB_HOST_MULTIARCH)" \
	            -docdir "/usr/share/qt5/doc" \
	            -headerdir "/usr/include/$(DEB_HOST_MULTIARCH)/qt5" \
	            -datadir "/usr/share/qt5" \
	            -archdatadir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5" \
	            -hostdatadir "/usr/share/qt5" \
	            -plugindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/plugins" \
	            -importdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/imports" \
	            -translationdir "/usr/share/qt5/translations" \
	            -hostdatadir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5" \
	            -sysconfdir "/etc/xdg" \
	            -examplesdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/examples" \
	            -opensource \
	            -plugin-sql-mysql \
	            -plugin-sql-odbc \
	            -plugin-sql-psql \
	            -plugin-sql-sqlite \
	            -no-sql-sqlite2 \
	            -plugin-sql-tds \
	            -system-sqlite \
	            -platform $(platform_arg) \
	            -system-zlib \
	            -system-libpng \
	            -system-libjpeg \
	            -openssl \
	            -no-rpath \
	            -verbose \
	            -optimized-qmake \
	            -dbus-linked \
	            -reduce-relocations \
		    -no-strip \
	            -no-separate-debug-info \
	            -qpa xcb \
	            -xcb \
	            -xkb-config-root "/usr/share/X11/xkb" \
	            -glib \
	            -icu \
	            -accessibility \
	            -compile-examples \
	            -no-directfb \
	            $(extra_configure_opts) \
	            $(cpu_opt)

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) confclean distclean

	# Extra stuff missed by confclean/distclean

	# Misc. files
	rm -f \
	  config.status \
	  config.tests/.qmake.cache \
	  examples/dbus/*/Makefile.* \
	  mkspecs/qconfig.pri \
	  src/corelib/global/qconfig.* \
	;

	# Misc. directories
	rm -rf \
	  doc-build/ \
	  doc/html/ \
	  doc/qch/ \
	  examples/tools/plugandpaint/plugins/ \
	  examples/tools/styleplugin/styles/ \
	  lib/ \
	  plugins/ \
	;

	# Leftover dirs
	find -depth -type d \( -false \
	  -o -name debug-shared \
	  -o -name debug-static \
	  -o -name \*.gch \
	  -o -name .moc\* \
	  -o -name .obj\* \
	  -o -name .pch \
	  -o -name pkgconfig \
	  -o -name .rcc \
	  -o -name release-shared \
	  -o -name release-static \
	  -o -name .uic \
	\) -print0 | xargs -0 rm -rf

	# Leftover files and all symlinks
	find \( -false \
	  -o -name \*.a \
	  -o -name Makefile.Debug \
	  -o -name Makefile.Release \
	  -o -name \*.o \
	  -o -name \*.prl \
	  -o -name \*.so \
	  -o -name \*.so.debug \
	  -o -type l \
	\) -print0 | xargs -0 rm -rf

	# Delete all Makefiles, excluding some from src/3rdparty
	find $(CURDIR) -name Makefile \
	  ! -path $(CURDIR)/src/3rdparty/Makefile \
	  ! -path $(CURDIR)/src/3rdparty/freetype/\* \
	  ! -path $(CURDIR)/src/3rdparty/zlib/\* \
	  ! -path $(CURDIR)/src/3rdparty/ptmalloc/Makefile \
	-print0 | xargs -0 rm -rf

	# Any remaining executables
	find $(CURDIR) -type f -perm /u+x,g+x,o+x -exec file -i '{}' \; \
	| grep -e application/x-executable \
	| cut -d ':' -f 1 | xargs rm -f

	# Generated on build
	rm -f debian/shlibs.local
	rm -f debian/stamp-makefile-build-tools

	# more leftovers
	rm -f .device.vars .qmake.vars

ifeq ($(vendor),Ubuntu)
	rm -rf po
endif

override_dh_auto_build-indep:
	cd $(CURDIR)/src; ../bin/qmake; make sub-qdoc
	cd $(CURDIR)/src/corelib; ../../bin/qmake
	cd $(CURDIR)/src/xml; ../../bin/qmake
	dh_auto_build -Smakefile -- html_docs

override_dh_auto_install-arch:
	dh_auto_install -Smakefile -- INSTALL_ROOT=$(CURDIR)/debian/tmp/

ifeq ($(DEB_HOST_ARCH_CPU),i386)
	# Rebuild the necessary libs with SSE2 support.
	# Create the destination directory.
	install -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/sse2/

	# corelib needs make clean first to be able to rebuild.
	cd $(CURDIR)/src/corelib; make clean ; ../../bin/qmake -config sse2; make
	cp -av lib/libQt5Core.so.* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/sse2/

	# gui on turn doesn't needs it, and actually fails if done.
	cd $(CURDIR)/src/gui; ../../bin/qmake -config sse2; make
	cp -av lib/libQt5Gui.so.* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/sse2/
endif

	# Fix wrong path in pkgconfig files

## qtbase-opensource-src 5.4.1+dfsg

=== debian/changelog ===
qtbase-opensource-src (5.4.1+dfsg-2) experimental; urgency=medium

  * mark_private_symbols.sh: Strip trailing colon from symbols names.
  * Symbols files:
    - Update from buildds’ logs.
    - Mark symbols missing with GCC 5 as optional.
    - Update for the above mark_private_symbols.sh change.
  * Drop obsolete override_dh_makeshlibs code, no longer needed.
    Just use dh_makeshlibs -V instead.
  * Fix CVE-2015-0295 vulnerability in BMP parser (closes: #779580).

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 03 Mar 2015 10:29:07 +0300

qtbase-opensource-src (5.4.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Update debian/watch to use https://download.qt.io/.
  * Drop patches that have been applied upstream:
    - upstream_qstorageinfo_unix.cpp-Fix-build-on-BSD-and-other-uni.patch.
    - upstream_qimage_conversions.cpp-Fix-build-on-big-endian-syste.patch.
  * Update symbols files.
  * Bump ABI version for the new release.
  * Use Files-Excluded copyright field for repacking source tarball.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 24 Feb 2015 19:08:44 +0300

qtbase-opensource-src (5.4.0+dfsg-6) experimental; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Fix qtbase5-dev.install-common. I screwed up in the last upload and pushed
    private headers into it.
    - Bump qtbase5-private-dev's Breaks and Replaces.
  * Move some OpenGL-related headers from qtbase5-dev.install-common to
    libqt5opengl5-dev.install.
    - Add proper Breaks and Replaces to libqt5opengl5-dev.
  * Headers installed into a versioned directory are always private. Simplify
    even further qtbase5-private-dev.install. Moreover this directories will
    always start with 5 during Qt 5's lifetime.
  * Make mark_private_symbols.sh unmark private symbols before processing them.
    This will help us detect symbols that became public.
    - Unmark new public symbols.
  * Mark libinput-dev as a linux-any build dependency. It is not available on
    hurd or kfreebsd.
  * Update symbols files with buildds' logs.

  [ Rohan Garg ]
  * Make sure we strip out the 'git' keyword when looking for changelogs to
    install
  * Improve globbing for the qtbase5-dev install file

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 19 Feb 2015 15:50:18 -0300

qtbase-opensource-src (5.4.0+dfsg-5) experimental; urgency=medium

  [ Pino Toscano ]
  * Replace patch hurd_opengl_incldir.diff with
    upstream_small-improvements-to-the-hurd-g-mkspec.patch, backport of
    upstream commit 8f0e84bec513ad28c3ec479053fbc59add3959e1.
  * Replace patch mips_more_pre-mips32.diff with
    upstream_Complete-MIPS-atomic-support-on-pre-MIPS32-architect.patch,
    backport of upstream commit 7ec14ae0b267780d6bfa5c7453c906caeee3bc00.
  * Replace patch bsd_statfs.diff with
    upstream_qstorageinfo_unix.cpp-Fix-build-on-BSD-and-other-uni.patch,
    backport of upstream commit 13972476ad2c3178fe89f2d96f398de10394c6f6.
  * Replace (rename) patch bigendian_qimage_conversions.diff with
    upstream_qimage_conversions.cpp-Fix-build-on-big-endian-syste.patch.
  * Update gnukfreebsd.diff according to the more recent hurd-g++ mkspec.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Add a note for packagers in qtbase5-dev and qt5-default's long
    descriptions.
  * Remove libopenvg1-mesa-dev as a build dependency because mesa does not
    builds it anymore (Closes: #777341).
    Thanks Andreas Beckmann for the report.
  * Add libinput-dev as build dependency, a test is looking for it.
  * Simplify qtbase5-dev.install-common and qtbase5-private-dev.install. It
    will easy the development of the packages.
    - Update qtbase5-private-dev's break+replaces against qtbase5-dev, files
      where moved between them.
    - Update symbols files to mark the new private symbols.
  * Add remove_privacy_breachs.diff in order to remove some non-used javascript
    code. It is not really needed, but it's the best way to calm down Lintian
    and be sure nothing will break in the future.
  * Do not ship libQt5Bootstrap, it's only used internally (Closes: #778717).
  * Do not ship docs' scripts empty directories.
  * Remove bogus exec bits from debian/tmp/usr/share/qt5/doc/*.

  [ Dmitry Shachnev ]
  * Drop private marks from QCollator, QOpenGLWidget and QAccessible*
    symbols.
  * Remove references to ia64 and s390 from the symbols files.
    Build logs for these architectures are no longer available.
  * Move QtOpenGL CMake files from qtbase5-dev to libqt5opengl5-dev.
  * Update debian/copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 19 Feb 2015 00:12:25 -0300

qtbase-opensource-src (5.4.0+dfsg-4) experimental; urgency=medium

  * debian/patches/bsd_statfs.diff: Third attempt to fix the build
    failure on kfreebsd.
  * Update symbols files for mips.

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 21 Dec 2014 13:22:29 +0300

qtbase-opensource-src (5.4.0+dfsg-3) experimental; urgency=medium

  * More debian/copyright updates.
  * Do not ship htmlinfo example which contains non-free HTML pages.
  * Drop remove_icon_from_example.patch and remove_google_adsense.patch,
    no longer needed with the above change.
  * Update symbols files with buildds’ logs.
  * debian/patches/bsd_statfs.diff: Second attempt to fix the build
    failure.

 -- Dmitry Shachnev <mitya57@debian.org>  Fri, 19 Dec 2014 16:06:58 +0300

qtbase-opensource-src (5.4.0+dfsg-2) experimental; urgency=medium

  * Add a patch to fix qstorageinfo_unix.cpp build on kFreeBSD.
  * Add a patch to fix qimage_conversions.cpp build on big endian
    systems.
  * Update symbols files with buildds’ logs.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 16 Dec 2014 14:42:27 +0300

qtbase-opensource-src (5.4.0+dfsg-1) experimental; urgency=medium

  [ Dmitry Shachnev ]
  * New upstream release.
  * Drop fix_bug_in_internal_comparison_operator.patch, applied upstream.
  * Drop fix_sparc_atomics.patch, applied upstream.


=== debian/control ===
--- 
+++ 
@@ -26,11 +26,12 @@
                libglib2.0-dev,
                libglu1-mesa-dev | libglu-dev,
                libgtk2.0-dev,
+               libharfbuzz-dev,
                libicu-dev,
+               libinput-dev [linux-any],
                libjpeg-dev,
                libmtdev-dev [linux-any],
                libmysqlclient-dev,
-               libopenvg1-mesa-dev [!hurd-any],
                libpng-dev,
                libpq-dev,
                libpulse-dev,
@@ -53,12 +54,14 @@
                libxcb1-dev,
                libxext-dev,
                libxi-dev,
+               libxkbcommon-dev,
+               libxkbcommon-x11-dev,
                libxrender-dev,
                pkg-kde-tools (>= 0.14.2),
                unixodbc-dev,
                zlib1g-dev
 Build-Conflicts: libmariadbclient-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://qt-project.org/
 Vcs-Git: git://anonscm.debian.org/pkg-kde/qt/qtbase.git
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/qt/qtbase.git
@@ -67,7 +70,7 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Provides: qtbase-abi-5-3-2
+Provides: qtbase-abi-5-4-1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: qttranslations5-l10n
 Suggests: libthai0
@@ -297,14 +300,17 @@
  .
  This package contains the header development files used for building Qt 5
  applications.
+ .
+ If you are interested in packaging Qt 5 stuff please take a look at
+ http://pkg-kde.alioth.debian.org/packagingqtstuff.html
 
 Package: qtbase5-private-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends: qtbase5-dev (= ${binary:Version}), ${misc:Depends}
-Breaks: qtbase5-dev (<< 5.3.2+dfsg-4~)
-Replaces: qtbase5-dev (<< 5.3.2+dfsg-4~)
+Breaks: qtbase5-dev (<< 5.4.0+dfsg-6~)
+Replaces: qtbase5-dev (<< 5.4.0+dfsg-6~)
 Description: Qt 5 base private development files
  Qt is a cross-platform C++ application framework. Qt's primary feature
  is its rich set of widgets that provide standard GUI functionality.
@@ -321,17 +327,10 @@
 Depends: libqt5opengl5 (= ${binary:Version}),
          qtbase5-dev (= ${binary:Version}),
          ${misc:Depends}
+Breaks: qtbase5-dev (<< 5.4.0+dfsg-6~)
+Replaces: qtbase5-dev (<< 5.4.0+dfsg-6~)
 Description: Qt 5 OpenGL library development files
  Qt is a cross-platform C++ application framework. Qt's primary feature
  is its rich set of widgets that provide standard GUI functionality.
  .
  This package contains the development files needed to build Qt 5 applications
- using QtOpenGL library.
-
-Package: qtbase5-dev-tools
-Architecture: any
-Multi-Arch: foreign
-Section: devel
-Depends: qtchooser, ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
-Description: Qt 5 base development programs
- Qt is a cross-platform C++ application framework. Qt's primary feature

=== debian/rules ===
--- 
+++ 
@@ -14,14 +14,8 @@
 export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
 export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed
 
-# Library package list for override_dh_makeshlibs, excludes -dev -dbg
-pkgs_lib := $(filter-out %-dev %-dbg,$(filter lib%,$(shell dh_listpackages)))
 # Upstream changelog
-upstream_changes := dist/changes-$(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-' | sed -e 's/+dfsg//')
-# Current debian version (e.g.: 4:4.5.2-1)
-current_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
-# Specific shlibs version (e.g.: 4:4.5.2)
-shlibs_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-')
+upstream_changes := dist/changes-$(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-' | sed -e 's/+dfsg//' | sed -e 's/+git.*//')
 # Distribution vendor
 vendor := $(shell dpkg-vendor --query Vendor)
 
@@ -116,6 +110,7 @@
 	            -plugin-sql-tds \
 	            -system-sqlite \
 	            -platform $(platform_arg) \
+	            -system-harfbuzz \
 	            -system-zlib \
 	            -system-libpng \
 	            -system-libjpeg \
@@ -129,7 +124,6 @@
 	            -no-separate-debug-info \
 	            -qpa xcb \
 	            -xcb \
-	            -xkb-config-root "/usr/share/X11/xkb" \
 	            -glib \
 	            -icu \
 	            -accessibility \
@@ -204,7 +198,6 @@
 	| cut -d ':' -f 1 | xargs rm -f
 
 	# Generated on build
-	rm -f debian/shlibs.local
 	rm -f debian/stamp-makefile-build-tools
 
 	# more leftovers
@@ -238,3 +231,11 @@
 endif
 
 	# Fix wrong path in pkgconfig files
+	find $(CURDIR)/debian/tmp/usr/lib/*/pkgconfig -type f -name '*.pc' \
+		-exec perl -pi -e "s, -L$(CURDIR)/?\S+,,g" {} \;
+
+	# Add a configuration for qtchooser
+	mkdir -p $(CURDIR)/debian/tmp/usr/share/qtchooser
+	echo "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/bin" > $(CURDIR)/debian/tmp/usr/share/qtchooser/qt5-$(DEB_HOST_MULTIARCH).conf
+	echo "/usr/lib/$(DEB_HOST_MULTIARCH)" >> $(CURDIR)/debian/tmp/usr/share/qtchooser/qt5-$(DEB_HOST_MULTIARCH).conf
+
